// Code generated by gowrap. DO NOT EDIT.
// template: ../../assets/templates/middleware/error_log
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/images -i Images -t ../../assets/templates/middleware/error_log -o error_logging_middleware.go -l ""

import (
	"context"

	"git.perx.ru/perxis/perxis-go/images"
	"git.perx.ru/perxis/perxis-go/pkg/files"
	"go.uber.org/zap"
)

// errorLoggingMiddleware implements images.Images that is instrumented with logging
type errorLoggingMiddleware struct {
	logger *zap.Logger
	next   images.Images
}

// ErrorLoggingMiddleware instruments an implementation of the images.Images with simple logging
func ErrorLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next images.Images) images.Images {
		return &errorLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *errorLoggingMiddleware) Get(ctx context.Context, source *files.File, opts *images.GetOptions) (result *files.File, err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.Get(ctx, source, opts)
}
